// TODO: put GPLv3 here

#include <avr/io.h>

#include "WDH3224.h"
#include "gram.h"


uint8_t g_ui8WDH3224_current_line;


void WDH3224_init()
{
    // init pins
    WDH3224_FRAME_SET_OUTPUT();
    WDH3224_FRAME_SET_LOW();

    WDH3224_NDISPOFF_SET_OUTPUT();
    WDH3224_NDISPOFF_SET_LOW();

    WDH3224_M_SET_OUTPUT();
    WDH3224_M_SET_LOW();

    WDH3224_LOAD_SET_OUTPUT();
    WDH3224_LOAD_SET_LOW();

    WDH3224_CLOCK_SET_OUTPUT();
    WDH3224_CLOCK_SET_LOW();

    // init vars
    g_ui8WDH3224_current_line = 0;
}


// TODO: check #pragma syntax (not supported in gcc prior to 4.4 -> put optimizations in makefile)
#pragma GCC optimize ("O3", "-funroll-loops")
void WDH3224_draw_next_line()
{
    // check/set FLM
    if (g_ui8WDH3224_current_line == 0)
        WDH3224_FRAME_SET_HIGH();

    gram_set_readmode();
    gram_set_address_high(g_ui8WDH3224_current_line);

    // ..unrolled.. a bit.. make gcc do the rest!
    uint8_t x;
    GRAM_ADDRESS_SET(0);
    for (x = 1; x < WDH3224_SIZE_X /4; x++)
    {
        WDH3224_CLOCK_SET_HIGH();
        WDH3224_CLOCK_SET_LOW();
        GRAM_ADDRESS_SET(x);
    }

    WDH3224_CLOCK_SET_HIGH();
    WDH3224_LOAD_SET_HIGH();
    WDH3224_CLOCK_SET_LOW();
    WDH3224_LOAD_SET_LOW();

    // clear FLM (note: always clear FLM.. avoids one 'if' statement)
    WDH3224_FRAME_SET_LOW();

    g_ui8WDH3224_current_line++;
    if (g_ui8WDH3224_current_line == WDH3224_SIZE_Y)
        g_ui8WDH3224_current_line = 0;
}

