// TODO: put GPLv3 here

#ifndef HAVE_WDH3224_h_2zjdb6o8dd9olcdj
#define HAVE_WDH3224_h_2zjdb6o8dd9olcdj

#include <avr/io.h>
#include <stdint.h>

// pinout -- FLM - first line marker - B2, 75-85Hz
#define WDH3224_FRAME_PORT             PORTB
#define WDH3224_FRAME_DDR              DDRB
#define WDH3224_FRAME                  2
#define WDH3224_FRAME_SET_OUTPUT()     ( WDH3224_FRAME_DDR  |=  (1 << WDH3224_FRAME) )
#define WDH3224_FRAME_SET_HIGH()       ( WDH3224_FRAME_PORT |=  (1 << WDH3224_FRAME) )
#define WDH3224_FRAME_SET_LOW()        ( WDH3224_FRAME_PORT &= ~(1 << WDH3224_FRAME) )

// pinout -- not display off - B4
#define WDH3224_NDISPOFF_PORT          PORTB
#define WDH3224_NDISPOFF_DDR           DDRB
#define WDH3224_NDISPOFF               4
#define WDH3224_NDISPOFF_SET_OUTPUT()  ( WDH3224_NDISPOFF_DDR  |=  (1 << WDH3224_NDISPOFF) )
#define WDH3224_NDISPOFF_SET_HIGH()    ( WDH3224_NDISPOFF_PORT |=  (1 << WDH3224_NDISPOFF) )
#define WDH3224_NDISPOFF_SET_LOW()     ( WDH3224_NDISPOFF_PORT &= ~(1 << WDH3224_NDISPOFF) )

// pinout -- M - AC drive - B3/OC0 - toggled via timer0 "toggle OC0 on compare match", 35-150Hz
#define WDH3224_M_PORT                 PORTB
#define WDH3224_M_DDR                  DDRB
#define WDH3224_M                      3
#define WDH3224_M_SET_OUTPUT()         ( WDH3224_M_DDR  |=  (1 << WDH3224_M) )
//#define WDH3224_M_SET_HIGH()           ( WDH3224_M_PORT |=  (1 << WDH3224_M) )
#define WDH3224_M_SET_LOW()            ( WDH3224_M_PORT &= ~(1 << WDH3224_M) )

// pinout -- load - data load/latch - D2
#define WDH3224_LOAD_PORT              PORTD
#define WDH3224_LOAD_DDR               DDRD
#define WDH3224_LOAD                   2
#define WDH3224_LOAD_SET_OUTPUT()      ( WDH3224_LOAD_DDR  |=  (1 << WDH3224_LOAD) )
#define WDH3224_LOAD_SET_HIGH()        ( WDH3224_LOAD_PORT |=  (1 << WDH3224_LOAD) )
#define WDH3224_LOAD_SET_LOW()         ( WDH3224_LOAD_PORT &= ~(1 << WDH3224_LOAD) )

// pinout -- cp - clock pulse - D3
#define WDH3224_CLOCK_PORT             PORTD
#define WDH3224_CLOCK_DDR              DDRD
#define WDH3224_CLOCK                  3
#define WDH3224_CLOCK_SET_OUTPUT()     ( WDH3224_CLOCK_DDR  |=  (1 << WDH3224_CLOCK) )
#define WDH3224_CLOCK_SET_HIGH()       ( WDH3224_CLOCK_PORT |=  (1 << WDH3224_CLOCK) )
#define WDH3224_CLOCK_SET_LOW()        ( WDH3224_CLOCK_PORT &= ~(1 << WDH3224_CLOCK) )

/* -- now in gram.h
// pinout -- data0 - D4
#define WDH3224_DATA0_PORT             PORTD
#define WDH3224_DATA0_DDR              DDRD
#define WDH3224_DATA0                  4
#define WDH3224_DATA0_SET_OUTPUT()     ( WDH3224_DATA0_DDR  |=  (1 << WDH3224_DATA0) )
#define WDH3224_DATA0_SET_HIGH()       ( WDH3224_DATA0_PORT |=  (1 << WDH3224_DATA0) )
#define WDH3224_DATA0_SET_LOW()        ( WDH3224_DATA0_PORT &= ~(1 << WDH3224_DATA0) )

// pinout -- data1 - D5
#define WDH3224_DATA1_PORT             PORTD
#define WDH3224_DATA1_DDR              DDRD
#define WDH3224_DATA1                  5
#define WDH3224_DATA1_SET_OUTPUT()     ( WDH3224_DATA1_DDR  |=  (1 << WDH3224_DATA1) )
#define WDH3224_DATA1_SET_HIGH()       ( WDH3224_DATA1_PORT |=  (1 << WDH3224_DATA1) )
#define WDH3224_DATA1_SET_LOW()        ( WDH3224_DATA1_PORT &= ~(1 << WDH3224_DATA1) )

// pinout -- data2 - D6
#define WDH3224_DATA2_PORT             PORTD
#define WDH3224_DATA2_DDR              DDRD
#define WDH3224_DATA2                  6
#define WDH3224_DATA2_SET_OUTPUT()     ( WDH3224_DATA2_DDR  |=  (1 << WDH3224_DATA2) )
#define WDH3224_DATA2_SET_HIGH()       ( WDH3224_DATA2_PORT |=  (1 << WDH3224_DATA2) )
#define WDH3224_DATA2_SET_LOW()        ( WDH3224_DATA2_PORT &= ~(1 << WDH3224_DATA2) )

// pinout -- data3
#define WDH3224_DATA3_PORT             PORTD
#define WDH3224_DATA3_DDR              DDRD
#define WDH3224_DATA3                  7
#define WDH3224_DATA3_SET_OUTPUT()     ( WDH3224_DATA3_DDR  |=  (1 << WDH3224_DATA3) )
#define WDH3224_DATA3_SET_HIGH()       ( WDH3224_DATA3_PORT |=  (1 << WDH3224_DATA3) )
#define WDH3224_DATA3_SET_LOW()        ( WDH3224_DATA3_PORT &= ~(1 << WDH3224_DATA3) )
*/


// dimensions
#define WDH3224_SIZE_X                  320
#define WDH3224_SIZE_Y                  240


void WDH3224_init();
void WDH3224_draw_next_line();


#endif // HAVE_WDH3224_h_2zjdb6o8dd9olcdj
